Index: /NEMO/releases/r4.0/r4.0-HEAD/tests/CANAL/EXPREF/namelist_cfg
===================================================================
--- /NEMO/releases/r4.0/r4.0-HEAD/tests/CANAL/EXPREF/namelist_cfg	(revision 13273)
+++ /NEMO/releases/r4.0/r4.0-HEAD/tests/CANAL/EXPREF/namelist_cfg	(revision 13274)
@@ -117,5 +117,5 @@
 &namdrg        !   top/bottom drag coefficient                          (default: NO selection)
 !-----------------------------------------------------------------------
-   ln_OFF     = .true.    !  free-slip       : Cd = 0
+   ln_drg_OFF = .true.    !  free-slip       : Cd = 0                  (F => fill namdrg_bot
 /
 !!======================================================================
Index: /NEMO/releases/r4.0/r4.0-HEAD/tests/ICE_ADV1D/EXPREF/namelist_cfg
===================================================================
--- /NEMO/releases/r4.0/r4.0-HEAD/tests/ICE_ADV1D/EXPREF/namelist_cfg	(revision 13273)
+++ /NEMO/releases/r4.0/r4.0-HEAD/tests/ICE_ADV1D/EXPREF/namelist_cfg	(revision 13274)
@@ -115,5 +115,5 @@
 &namdrg        !   top/bottom drag coefficient                          (default: NO selection)
 !-----------------------------------------------------------------------
-   ln_OFF     = .true.     !  free-slip       : Cd = 0                  
+   ln_drg_OFF = .true.     !  free-slip       : Cd = 0                  (F => fill namdrg_bot
 /
 !!======================================================================
Index: /NEMO/releases/r4.0/r4.0-HEAD/tests/ICE_ADV2D/EXPREF/namelist_cfg
===================================================================
--- /NEMO/releases/r4.0/r4.0-HEAD/tests/ICE_ADV2D/EXPREF/namelist_cfg	(revision 13273)
+++ /NEMO/releases/r4.0/r4.0-HEAD/tests/ICE_ADV2D/EXPREF/namelist_cfg	(revision 13274)
@@ -115,5 +115,5 @@
 &namdrg        !   top/bottom drag coefficient                          (default: NO selection)
 !-----------------------------------------------------------------------
-   ln_OFF     = .true.     !  free-slip       : Cd = 0                  
+   ln_drg_OFF = .true.     !  free-slip       : Cd = 0                  (F => fill namdrg_bot
 /
 !!======================================================================
Index: /NEMO/releases/r4.0/r4.0-HEAD/tests/ISOMIP/EXPREF/namelist_cfg
===================================================================
--- /NEMO/releases/r4.0/r4.0-HEAD/tests/ISOMIP/EXPREF/namelist_cfg	(revision 13273)
+++ /NEMO/releases/r4.0/r4.0-HEAD/tests/ISOMIP/EXPREF/namelist_cfg	(revision 13274)
@@ -137,5 +137,5 @@
 &namdrg        !   top/bottom drag coefficient                          (default: NO selection)
 !-----------------------------------------------------------------------
-   ln_OFF     = .false.    !  free-slip       : Cd = 0                  (F => fill namdrg_bot
+   ln_drg_OFF = .false.   !  free-slip       : Cd = 0                  (F => fill namdrg_bot
    ln_lin     = .false.    !      linear  drag: Cd = Cd0 Uc0                   &   namdrg_top)
    ln_non_lin = .true.     !  non-linear  drag: Cd = Cd0 |U|
Index: /NEMO/releases/r4.0/r4.0-HEAD/tests/LOCK_EXCHANGE/EXPREF/namelist_FCT2_flux_ubs_cfg
===================================================================
--- /NEMO/releases/r4.0/r4.0-HEAD/tests/LOCK_EXCHANGE/EXPREF/namelist_FCT2_flux_ubs_cfg	(revision 13273)
+++ /NEMO/releases/r4.0/r4.0-HEAD/tests/LOCK_EXCHANGE/EXPREF/namelist_FCT2_flux_ubs_cfg	(revision 13274)
@@ -121,5 +121,5 @@
 &namdrg            !   top/bottom drag coefficient                      (default: NO selection)
 !-----------------------------------------------------------------------
-   ln_OFF     = .true.    !  free-slip       : Cd = 0                  
+   ln_drg_OFF = .true.    !  free-slip       : Cd = 0                  (F => fill namdrg_bot
 /
 !!======================================================================
Index: /NEMO/releases/r4.0/r4.0-HEAD/tests/OVERFLOW/EXPREF/namelist_zps_FCT4_flux_ubs_cfg
===================================================================
--- /NEMO/releases/r4.0/r4.0-HEAD/tests/OVERFLOW/EXPREF/namelist_zps_FCT4_flux_ubs_cfg	(revision 13273)
+++ /NEMO/releases/r4.0/r4.0-HEAD/tests/OVERFLOW/EXPREF/namelist_zps_FCT4_flux_ubs_cfg	(revision 13274)
@@ -114,5 +114,5 @@
 &namdrg        !   top/bottom drag coefficient                          (default: NO selection)
 !-----------------------------------------------------------------------
-   ln_OFF     = .true.     !  free-slip       : Cd = 0                  (F => fill namdrg_bot
+   ln_drg_OFF = .true.     !  free-slip       : Cd = 0                  (F => fill namdrg_bot
    ln_lin     = .false.    !      linear  drag: Cd = Cd0 Uc0                   &   namdrg_top)
    ln_non_lin = .false.    !  non-linear  drag: Cd = Cd0 |U|
Index: /NEMO/releases/r4.0/r4.0-HEAD/tests/VORTEX/EXPREF/1_namelist_cfg
===================================================================
--- /NEMO/releases/r4.0/r4.0-HEAD/tests/VORTEX/EXPREF/1_namelist_cfg	(revision 13273)
+++ /NEMO/releases/r4.0/r4.0-HEAD/tests/VORTEX/EXPREF/1_namelist_cfg	(revision 13274)
@@ -116,5 +116,5 @@
 &namdrg        !   top/bottom drag coefficient                          (default: NO selection)
 !-----------------------------------------------------------------------
-   ln_OFF     = .true.    !  free-slip       : Cd = 0
+   ln_drg_OFF = .true.     !  free-slip       : Cd = 0                  (F => fill namdrg_bot
 /
 !!======================================================================
Index: /NEMO/releases/r4.0/r4.0-HEAD/tests/VORTEX/EXPREF/namelist_cfg
===================================================================
--- /NEMO/releases/r4.0/r4.0-HEAD/tests/VORTEX/EXPREF/namelist_cfg	(revision 13273)
+++ /NEMO/releases/r4.0/r4.0-HEAD/tests/VORTEX/EXPREF/namelist_cfg	(revision 13274)
@@ -108,5 +108,5 @@
 &namdrg        !   top/bottom drag coefficient                          (default: NO selection)
 !-----------------------------------------------------------------------
-   ln_OFF     = .true.    !  free-slip       : Cd = 0
+   ln_drg_OFF  = .true.   !  free-slip       : Cd = 0                  (F => fill namdrg_bot
 /
 !!======================================================================